PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Classes | Public Member Functions | Protected Attributes | List of all members
PAsyncNotifierFunction< ParamType > Class Template Reference

This is an abstract class for which a descendent is declared for every function that may be called. More...

`#include <notifier_ext.h>`

Inheritance diagram for PAsyncNotifierFunction< ParamType >:
[legend]
Collaboration diagram for PAsyncNotifierFunction< ParamType >:
[legend]

## Classes
class | TypedCallback

## Public Member Functions
| PAsyncNotifierFunction (void *voidTarget, PAsyncNotifierTarget *notifierTarget)
Public Member Functions inherited from PNotifierFunctionTemplate< ParamType >
virtual void | Call (PObject &notifier, ParamType extra) const =0
| Execute the call to the actual notification function on the object instance contained in this object. More...
virtual void * | GetTarget () const
Public Member Functions inherited from PSmartObject
| PSmartObject ()
| Construct a new smart object, subject to a `PSmartPointer` instance referencing it. More...
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Attributes
PNotifierIdentifer | m_targetID
Protected Attributes inherited from PNotifierFunctionTemplate< ParamType >
void * | m_target
| Object instance to receive the notification function call. More...
Protected Attributes inherited from PSmartObject
PAtomicInteger | referenceCount
| Count of number of instances of `PSmartPointer` that currently reference the object instance. More...
Protected Attributes inherited from PObject
unsigned | m_traceContextIdentifier

## Additional Inherited Members
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
Protected Member Functions inherited from PNotifierFunctionTemplate< ParamType >
| PNotifierFunctionTemplate (void *target, void *=NULL)
| Create a notification function instance. More...
Friends inherited from PObject

## Detailed Description

### template<typename ParamType>
class PAsyncNotifierFunction< ParamType >

This is an abstract class for which a descendent is declared for every function that may be called.

The `PDECLARE_ASYNC_NOTIFIER` macro makes this declaration.

See PNotifierFunctionTemplate for more information.

Note: the user must be very careful with the type of ParamType. The lifetime must be guaranteed until the PAsyncNotifierTarget::AsyncNotifierExecute() function is called. It is usually easier to simply make sure the data is passed by value and never pointer or reference.

## Constructor & Destructor Documentation

template<typename ParamType >

PAsyncNotifierFunction< ParamType >::PAsyncNotifierFunction | ( | void * | voidTarget,
|  | PAsyncNotifierTarget * | notifierTarget
| ) |  |
| inline

## Member Data Documentation

template<typename ParamType >

PNotifierIdentifer PAsyncNotifierFunction< ParamType >::m_targetID
| protected

The documentation for this class was generated from the following file:

- notifier_ext.h